Index: /trunk/src/VBox/Additions/linux/installer/vboxadd-x11.sh
===================================================================
--- /trunk/src/VBox/Additions/linux/installer/vboxadd-x11.sh	(revision 50311)
+++ /trunk/src/VBox/Additions/linux/installer/vboxadd-x11.sh	(revision 50312)
@@ -296,4 +296,9 @@
         test -c /dev/psaux && nopsaux="";;
     esac
+    # Should we use the VMSVGA driver instead of VBoxVideo?
+    vmsvga=""
+    if ! grep 80eebeef /proc/bus/pci/devices > /dev/null; then
+        vmsvga="--vmsvga"
+    fi
     # The video driver to install for X.Org 6.9+
     vboxvideo_src=
@@ -340,10 +345,10 @@
             xserver_version="X.Org Server 1.11"
             vboxvideo_src=vboxvideo_drv_111.so
-            test "$system" = "redhat" || setupxorgconf=""
+            test "$system" = "redhat" && test -z "${vmsvga}" || setupxorgconf=""
             ;;
         1.10.* )
             xserver_version="X.Org Server 1.10"
             vboxvideo_src=vboxvideo_drv_110.so
-            test "$system" = "redhat" || setupxorgconf=""
+            test "$system" = "redhat" && test -z "${vmsvga}" || setupxorgconf=""
             ;;
         1.9.* )
@@ -351,5 +356,5 @@
             vboxvideo_src=vboxvideo_drv_19.so
             # Fedora 14 to 16 patched out vboxvideo detection
-            test "$system" = "redhat" || setupxorgconf=""
+            test "$system" = "redhat" && test -z "${vmsvga}" || setupxorgconf=""
             ;;
         1.8.* )
@@ -357,5 +362,5 @@
             vboxvideo_src=vboxvideo_drv_18.so
             # Fedora 13 shipped without vboxvideo detection
-            test "$system" = "redhat" || setupxorgconf=""
+            test "$system" = "redhat" && test -z "${vmsvga}" || setupxorgconf=""
             ;;
         1.7.* )
@@ -479,5 +484,5 @@
                         generated="$generated  `printf "$i\n"`"
                     else
-                        "$lib_dir/x11config.sh" $autokeyboard $automouse $nopsaux "$i"
+                        "$lib_dir/x11config.sh" $autokeyboard $automouse $nopsaux $vmsvga "$i"
                     fi
                     configured="true"
@@ -492,5 +497,5 @@
             if test -z "$configured"; then
                 touch "$main_cfg"
-                "$lib_dir/x11config.sh" $autokeyboard $automouse $nopsaux --noBak "$main_cfg"
+                "$lib_dir/x11config.sh" $autokeyboard $automouse $nopsaux $vmsvga --noBak "$main_cfg"
                 touch "${nobak_cfg}"
             fi
Index: /trunk/src/VBox/Additions/x11/Installer/x11config.sh
===================================================================
--- /trunk/src/VBox/Additions/x11/Installer/x11config.sh	(revision 50311)
+++ /trunk/src/VBox/Additions/x11/Installer/x11config.sh	(revision 50312)
@@ -18,4 +18,5 @@
 no_bak=""
 old_mouse_dev="/dev/psaux"
+video_driver="vboxvideo"
 
 tab=`printf '\t'`
@@ -118,5 +119,5 @@
 Section "Device"
   BoardName    "VirtualBox Graphics"
-  Driver       "vboxvideo"
+  Driver       "${video_driver}"
   Identifier   "Device[0]"
   VendorName   "Oracle Corporation"
@@ -149,4 +150,6 @@
         --nopsaux)
             old_mouse_dev="/dev/input/mice" ;;
+        --vmsvga)
+            video_driver="vmware" ;;
         *)
             reconfigure "$1" ;;
